package scphEditor;

import java.awt.Component;

/**
 * This is the view class/object for a null Operand.
 */
public class NullView extends AtomView implements OperandView
{
  /**
   * Creates NullView object.
   *
   * @param c the control object (event listener) for me.
   */
  public NullView(OperandControl c)
  {
    super("_");

    addMouseListener(c);
    addKeyListener(c);
  }

  public Operand getOperand()
  {
    return null;
  }

  public OperandVector getOperandVector()
  {
    return null;
  }

  public int operandIndex(Component child)
  {
    return -1;                  // or throw exception?
  }

  public Component getOperandView(int opindex)
  {
    return null;                // or throw exception?
  }
}
