package scphEditor;

import java.awt.Component;
import java.awt.Container;

/**
 * This class is a simple record containing the context of an operand,
 * i.e., itself, its position index in its parent, and the parent.
 */
public class OperandContext
{
  /**
   * Itself.
   */
  public Operand self;
  /**
   * Parent.
   */
  public OperandVector parent;
  /**
   * Display rep of itself.
   */
  public Component selfview;
  /**
   * Display rep of parent.
   */
  public Container parentview;
  /**
   * Its position in parent.
   */
  public int index;

  public OperandContext(Component oview)
  {
    selfview = oview;
    self = ((OperandView) oview).getOperand();
    parentview = oview.getParent();
    parent = ((OperandVectorView) parentview).getOperandVector();
    index = ((OperandVectorView) parentview).operandIndex(selfview);
  }
}
