package scphEditor;

import java.awt.*;
import java.awt.event.*;

import org.eclipse.swt.widgets.Display;

public class ProofMenu {
  private void waiting(boolean w) {
  }

  public void actionPerformed(ActionEvent e) {
    String cmd = e.getActionCommand();
    Component selected = ScphEditorContributor.recent.editor_widget.getSelection();
    if (selected == null)
      return;
    OperandContext c = new OperandContext(selected);
    if (cmd.equals("Send"))
      send(c);
    else if (cmd.equals("Simplify"))
      simplify(c);
    else if (cmd.equals("Logic"))
      tautology(c);
    else if (cmd.equals("Grind"))
      grind(c);
    else if (cmd.equals("Stop"))
      ProverShell.instance().interrupt();
  }

  public void send(OperandContext c) {
    if (c == null)
      return;
    TermBuilder b = new TermBuilder();
    ProverShell.instance().execute(
        "embedding.downcast (--`" + b.make(c.self) + "`--);");
  }

  class PostConvert implements ProverShell.IPostExecute {
    private OperandContext c;

    public PostConvert(OperandContext c) {
      this.c = c;
    }

    public void postExecute(final String output) {
      Display.getDefault().syncExec(new Runnable() {
        public void run() {
          Workspace e = ScphEditorContributor.recent.editor_widget;
          Expression eq = new Expression(OperatorStore.getById("EQ"));
          eq.setChild((Operand) c.self.clone(), 0);
          eq.setChild(TermBuilder.make(output), 1);
          eq.setSplit(true);
          e.getWork().addChild(eq, -1);
          e.validate();
          waiting(false);
        }
      });
    }
  }

  private void convert(String cmd, OperandContext c) {
    waiting(true);
    ProverShell.instance().execute(
        "val _ = util.convert (" + cmd + ") `" + new TermBuilder().make(c.self)
            + "`;", new PostConvert(c));
  }

  class PostQED implements ProverShell.IPostExecute {
    private OperandContext c;

    public PostQED(OperandContext c) {
      this.c = c;
    }

    public void postExecute(final String output) {
      Display.getDefault().syncExec(new Runnable() {
        public void run() {
          Workspace e = ScphEditorContributor.recent.editor_widget;
          if (TermBuilder.make(output) != null) {
            e.getWork().addChild((Operand) c.self.clone(), -1);
            e.validate();
          } else {
            e.getWork().addChild(null, -1);
            e.validate();
          }
          waiting(false);
        }
      });
    }
  }

  private void qed(String cmd, OperandContext c) {
    waiting(true);
    ProverShell.instance().execute(
        "val _ = util.qed (" + cmd + ") `" + new TermBuilder().make(c.self)
            + "`;", new PostQED(c));
  }

  public void simplify() {
    Component selected = ScphEditorContributor.recent.editor_widget.getSelection();
    if (selected == null)
      return;
    OperandContext c = new OperandContext(selected);
    simplify(c);
  }

  public void simplify(OperandContext c) {
    convert("simpLib.SIMP_CONV util.arith_ss []", c);
  }

  public void tautology(OperandContext c) {
    qed("bossLib.PROVE [] o util.quote", c);
  }

  public void grind(OperandContext c) {
    qed("util.bytac (bossLib.RW_TAC util.arith_ss [])", c);
  }
}