package scphEditor;

import java.awt.*;

public class RowLayout implements LayoutManager
{
  private int gap;

  public RowLayout()
  {
    gap = 0;
  }

  public RowLayout(int g)
  {
    gap = g;
  }

  public int getGap()
  {
    return gap;
  }

  public void setGap(int g)
  {
    gap = g;
  }

  public void addLayoutComponent(String s, Component com)
  {
  }

  public void removeLayoutComponent(Component com)
  {
  }

  public Dimension minimumLayoutSize(Container con)
  {
    return preferredLayoutSize(con);
  }

  public Dimension preferredLayoutSize(Container con)
  {
    Dimension ps = new Dimension(0, 0);
    Component[] coms = con.getComponents();
    for (int i = 0; i < coms.length; i++) {
      Dimension s = coms[i].getPreferredSize();
      ps.height += s.height;
      if (ps.width < s.width) ps.width = s.width;
      if (i < coms.length - 1) ps.height += gap;
    }
    return ps;
  }

  public void layoutContainer(Container con)
  {
    int cx = 0, cy = 0;
    Component[] coms = con.getComponents();
    for (int i = 0; i < coms.length; i++) {
      Dimension s = coms[i].getPreferredSize();
      coms[i].setSize(s);
      coms[i].setLocation(cx, cy);
      cy += s.height + gap;
    }
  }
}
