package scphEditor;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.part.EditorActionBarContributor;

public class ScphEditorContributor extends EditorActionBarContributor {

  static ScphEditorPart recent = null;

  /**
   * Remembers the most recent active proof editor.
   * (Mainly for viewers to insert stuff into the right guy.)
   */
  public void setActiveEditor(IEditorPart targetEditor) {
    if (targetEditor instanceof ScphEditorPart) {
      recent = (ScphEditorPart) targetEditor;
    }
  }

  Action copy, split, flat, swap, ungroup, simplify;

  public ScphEditorContributor() {
    super();
    copy = new Action("Copy") {
      public void run() {
        if (recent != null) {
          recent.editor_widget.copy();
        }
      }      
    };
    split = new Action("Split") {
      public void run() {
        if (recent != null) {
          recent.editor_widget.split(true);
        }
      }      
    }; 
    flat = new Action("Flat") {
      public void run() {
        if (recent != null) {
          recent.editor_widget.split(false);
        }
      }      
    }; 
    swap = new Action("Swap") {
      public void run() {
        if (recent != null) {
          recent.editor_widget.swap();
        }
      }      
    }; 
    ungroup = new Action("Ungroup") {
      public void run() {
        if (recent != null) {
          recent.editor_widget.ungroup();
        }
      }      
    }; 
    simplify = new Action("Simplify") {
      public void run() {
        if (recent != null) {
          new ProofMenu().simplify();
        }
      }      
    }; 
  }

  public void contributeToToolBar(IToolBarManager toolBarManager) {
    super.contributeToToolBar(toolBarManager);
    toolBarManager.add(new Separator("ScphEditor"));
    toolBarManager.add(copy);
    toolBarManager.add(split);
    toolBarManager.add(flat);
    toolBarManager.add(swap);
    toolBarManager.add(ungroup);
    toolBarManager.add(simplify);
  }

}
