package scphEditor;

import java.io.*;
import java.util.Observable;

public class Shell extends Observable implements Runnable
{
  private String processName;
  private Process process;
  private BufferedReader processOut; // hehe the senses are reversed
  private Writer processIn;          // this too
  private Thread waiter;
  private boolean alive;

  public Shell(String pName) throws IOException
  {
    processName = pName;
    process = Runtime.getRuntime().exec(processName);
    //    processIn = new BufferedWriter(new OutputStreamWriter(process.getOutputStream()));
    processIn = new OutputStreamWriter(process.getOutputStream());
    processOut = new BufferedReader(new InputStreamReader(process.getInputStream()));
    waiter = new Thread(this);
  }

  public void start()
  {
    waiter.start();
  }

  public void execute(String cmd) throws IOException
  {
    processIn.write(cmd);
    if (!cmd.endsWith("\n")) processIn.write("\n");
    processIn.flush();
  }

  public void interrupt() {
    try {
      processIn.write(3);
      processIn.flush();
    }
    catch (IOException ex) {
    }
  }

  public boolean isAlive()
  {
    return alive;
  }

  public void run()
  {
    alive = true;
    try {
      readChars();
    }
    catch (IOException e) {
      System.out.println(e.getMessage());
    }
    alive = false;
  }

  private void readLines() throws IOException
  {
    String s;

    for (;;) {
      s = processOut.readLine();
      if (s == null) break;
      setChanged();
      notifyObservers(s + "\n");
    }
  }

  private void readChars() throws IOException
  {
    int len;
    char[] buf = new char[2048];

    for (;;) {
      len = processOut.read(buf);
      if (len == -1) break;
      setChanged();
      notifyObservers(new String(buf, 0, len));
    }
  }

  public void kill()
  {
    try {
      processIn.close();
    }
    catch (IOException e) {
    }
    try {
      processOut.close();
    }
    catch (IOException e) {
    }
    //process.destroy();
  }
}
