package scphEditor;
import java.awt.*;

public class VariableView extends IdentifierView
{
  // seperates variable name and variable type in display
  private static String delimiter = " : ";

  public VariableView(Variable idOf, OperandControl c)
  {
    super(idOf, c);
  }

  public Dimension getMinimumSize()
  {
    Variable v = (Variable)getOperand();
    FontMetrics vfm = getFontMetrics(Workspace.IDFONT);
    FontMetrics tfm = getFontMetrics(Workspace.TEXTFONT);
    return new Dimension(vfm.stringWidth(v.getName()) +
                         tfm.stringWidth(delimiter + v.getType()),
                         Math.max(vfm.getHeight(), tfm.getHeight()));
  }

  public void paint(Graphics g)
  {
    Dimension size = getSize();
    Variable v = (Variable)getOperand();
    g.setColor(getBackground());
    g.fillRect(0, 0, size.width, size.height);
    g.setColor(getForeground());
    g.setFont(Workspace.IDFONT);
    g.drawString(v.getName(), 0, g.getFontMetrics().getAscent());
    int w = g.getFontMetrics().stringWidth(v.getName());
    g.setFont(Workspace.TEXTFONT);
    g.drawString(delimiter + v.getType(), w, g.getFontMetrics().getAscent());
  }
}
